#define _CRTDBG_MAP_ALLOC
#include <stdlib.h>
#include <crtdbg.h>

#include <stdlib.h>
#include <stdio.h>
#include "dama.h"
#include "susjed.h"


#define TRUE	1
#define FALSE	0

void game::postavi(int polje, piece sadrzaj)
{
	if ((polje < 0) || (polje >= 50))
		return;

	pozicija[polje] = sadrzaj;
}


void game::pocetna_pozicija(void)
{
	int	i = 0;

	while (i < 20)
		postavi(i++, CRNI);

	while (i < 30)
		postavi(i++, PRAZNO);

	while (i < 50)
		postavi(i++, BIJELI);

	fig_bijeli = fig_crni = 20;
	potez = 0;
	figura = BIJELI;
}


int game::moguci_potezi(void)
{
	udarni_potez(pozicija);
	if (count == 0)
		tihi_potez(pozicija);
	return count;
}


void game::udarni_potez(piece *poz)
{
	maxlevel = count = 0;
	for ( polje_start = 0; polje_start < 50; ++polje_start ) {
		if ( poz [polje_start] == figura )
			skok ( poz, polje_start, 0 );
		else if ( poz [polje_start] == 2 * figura )
			skok_dame ( poz, polje_start, 0, -1 );
	}
	for (int n = 0; n < count; ++n) {
		int sa = POLJE[n].sa;
		int na = POLJE[n].na;
		int *preko = POLJE[n].preko;
		for (int m = n + 1; m < count; ++m) {
			if (POLJE[m].sa != sa) continue;
			if (POLJE[m].na != na) continue;
			int *tmp = (int *)malloc(maxlevel*sizeof(int));
			for (int lm = 0; lm < maxlevel; ++lm)
				tmp[lm] = POLJE[m].preko[lm];
			int ml = maxlevel;
			for (int ln = 0; ln < maxlevel; ++ln) {
				int pr = preko[ln];
				for (int lm = 0; lm < ml; ++lm) {
					if (pr != tmp[lm]) continue;
					tmp[lm--] = tmp[--ml];
				}
			}
			free(tmp);
			if (ml == 0) {
				free(POLJE[m].preko);
				POLJE[m].preko = NULL;
				for (int mm = m+1; mm < count; ++mm) {
					POLJE[mm-1].sa = POLJE[mm].sa;
					POLJE[mm-1].na = POLJE[mm].na;
#ifdef _DEBUG
					if (POLJE[mm-1].preko != NULL) {
						free(POLJE[mm-1].preko);
						POLJE[mm-1].preko = NULL;
					}
#endif
					POLJE[mm-1].preko = POLJE[mm].preko;
				}
				--count;
				--m;
			}
		}
	}
}

void game::skok_dame(piece *poz, int polje, int level, int SMJER)
{
	int	polje1, polje2, smjer, i;
	char  njup = FALSE;

	for ( smjer = 0; smjer < 4; ++smjer ) {
		if ( ( polje1 = susjed [polje] [smjer] ) < 0 )
			continue;
			if ( ( smjer == SMJER ) && ( poz[polje1] == PRAZNO ) )
				continue;
		while ( polje1 >= 0 ) {
			if ( poz [polje1] != PRAZNO ) {
				if ( ( ( poz [polje1] ^ poz [polje] ) & 0x80 ) != 0 ) {
					for ( polje2 = susjed [polje1] [smjer]; polje2 >= 0; )
					if ( poz [polje2] == PRAZNO ) {
					piece poz1[50];
						njup = TRUE;
						inter [level] = polje1;
						for ( i = 0; i < 50; ++i )
						poz1 [i] = poz [i];
						poz1 [polje1] = poz1 [polje2] = poz1 [polje];
						poz1 [polje] = PRAZNO;
						skok_dame ( poz1, polje2, level + 1, smjer );
						polje2 = susjed [polje2] [smjer];
					}
					else
						polje2 = -1;
				}
				polje1 = -1;
			}
			else
				polje1 = susjed [polje1] [smjer];
		}
	}
	if ( !njup  && ( level > 0 ) ) {
		if ( level > maxlevel ) {
			maxlevel = level;
			for ( i = 0; i < count; ++i ) {
				free ( POLJE[i].preko );
				POLJE[i].preko = NULL;
			}
			count = 0;
		}
		if ( level == maxlevel ) {
			POLJE[count].sa = polje_start;
			POLJE[count].na = polje;
			POLJE[count].preko = (int *)realloc(POLJE[count].preko, level * sizeof(int));
			for ( i = 0; i < level; ++i )
				*(POLJE[count].preko+i) = inter [i];
			++count;
		}
	}
}

void game::skok(piece *poz, int polje, int level)
{
	int	polje1, polje2, smjer, i;
	char njup = FALSE;

	for ( smjer = 0; smjer < 4; ++smjer ) {
		if ( ( polje1 = susjed [polje][smjer] ) >= 0 )
			if ( ( polje2 = susjed [polje1][smjer] ) >= 0 )
				if (	( poz [polje2] == PRAZNO ) &&
						( poz [polje1] != PRAZNO ) &&
					( ( ( poz [polje1] ^ poz [polje] ) & 0x80 ) != 0 ) ) {
				piece poz1[50];
					njup = TRUE;
					inter [level] = polje1;
					for ( i = 0; i < 50; ++i )
						poz1 [i] = poz [i];
					poz1 [polje1] = poz1 [polje2] = poz1 [polje];
					poz1 [polje] = PRAZNO;
					skok ( poz1, polje2, level + 1 );
				}
	}
	if ( !njup  && ( level > 0 ) ) {
		if ( level > maxlevel ) {
			maxlevel = level;
			for ( i = 0; i < count; ++i ) {
				free ( POLJE[i].preko );
				POLJE[i].preko = NULL;
			}
			count = 0;
		}
		if ( level == maxlevel ) {
			POLJE[count].sa = polje_start;
			POLJE[count].na = polje;
			//POLJE[count].preko = (int *)malloc(level * sizeof(int));
			POLJE[count].preko = (int *)realloc(POLJE[count].preko, level * sizeof(int));
			for ( i = 0; i < level; ++i )
				*(POLJE[count].preko+i) = inter [i];
			++count;
		}
	}
}

void game::tihi_potez(piece *poz)
{
	int	polje, polje1, smjer;

	count = 0;
	for ( polje = 0; polje < 50; ++polje )
		if ( poz [polje] == figura ) {
			for ( smjer = 0; smjer < 2; ++smjer )
				if ( ( polje1 = susjed [polje][smjer+1-figura] ) >= 0 )
					if ( ( poz [polje1] == PRAZNO ) ) {
#ifdef _DEBUG
						if (POLJE[count].preko != NULL) {
							free(POLJE[count].preko);
							POLJE[count].preko = NULL;
						}
#endif
						POLJE[count].preko = NULL;
						POLJE[count].sa		= polje;
						POLJE[count++].na	= polje1;
					}
		}
		else if ( poz [polje] == 2 * figura ) {
			for ( smjer = 0; smjer < 4; ++smjer )
				for ( polje1 = susjed [polje][smjer]; polje1 >= 0; )
					if ( ( poz [polje1] == PRAZNO ) ) {
#ifdef _DEBUG
						if (POLJE[count].preko != NULL) {
							free(POLJE[count].preko);
							POLJE[count].preko = NULL;
						}
#endif
						POLJE[count].preko = NULL;
						POLJE[count].sa		= polje;
						POLJE[count++].na	= polje1;
						polje1 = susjed [polje1][smjer];
					}
					else
						polje1 = -1;
		}
		
}


char *game::display(int sel, char *buff)
{
	static char tmp[32];
	if (buff == NULL) buff = tmp;

	char sep = (POLJE[sel].preko == NULL) ? '-' : 'x';
	sprintf(buff, "%d%c%d", POLJE[sel].sa+1, sep, POLJE[sel].na+1);

	return buff;
}

static int getEnd(int sa, int na, int pr) {
	int y1 = sa / 5;
	int x1 = (sa % 5) * 2;
	if ((y1 % 2) == 0) ++x1;

	int y2 = na / 5;
	int x2 = (na % 5) * 2;
	if ((y2 % 2) == 0) ++x2;

	int y0 = pr / 5;
	int x0 = (pr % 5) * 2;
	if ((y0 % 2) == 0) ++x0;

	int c1, c2;
	if (x2 == x1)
		c1 = -999;
	else
		c1 = (y2 - y1) / (x2 - x1);

	if (x0 == x2)
		c2 = +999;
	else
		c2 = (y0 - y2) / (x0 - x2);

	int x, y;

	if ((c1 != 0) && (c1 == c2)) {
		if (x1 > x2) {
			x = x0 - 1;
			y = y0 - c1;
		} else {
			x = x0 + 1;
			y = y0 + c1;
		}
	} else {
		int C = (y0 - y1) / (x0 - x1);

		x = (C * (x1 + x2) + (y2 - y1)) / (2 * C);
		y = C * (x - x1) + y1;
	}

	return 5 * y + (x / 2);

}

char *game::fullDisplay(int sel, char *buff)
{
	static char tmp[32];
	if (buff == NULL) buff = tmp;

	if (POLJE[sel].preko == NULL) {
		sprintf(buff, "%d-%d", POLJE[sel].sa+1, POLJE[sel].na+1);
	} else {
		int start = POLJE[sel].sa;
		sprintf(buff, "%d:", start+1);
		char *p = buff + strlen(buff);
		int end;
		for (int n = 1; n < maxlevel; ++n) {
			end = getEnd(start, POLJE[sel].preko[n], POLJE[sel].preko[n-1]);
			sprintf(p, "%d:", end+1);
			p += strlen(p);
			start = end;
		}
		//end = getEnd(start, POLJE[sel].na, POLJE[sel].preko[maxlevel-1]);
		sprintf(p, "%d", POLJE[sel].na+1);
	}

	return buff;
}

char *game::MakeMove(int from, int to, char *buff)
{
	int sel = MoveNumber(from, to);
	if (sel < 0)
		return NULL;

	if ((pozicija[POLJE[sel].na] != PRAZNO) && ((POLJE[sel].sa != POLJE[sel].na)))
		return NULL;

	if ((pozicija[POLJE[sel].sa] != figura) && (pozicija[POLJE[sel].sa] != 2*figura))
		return NULL;

	if (POLJE[sel].preko != NULL) {
		piece f = (figura == BIJELI) ? CRNI : BIJELI;
		for (int m = maxlevel; --m >= 0; )
			if ((pozicija[POLJE[sel].preko[m]] != f) &&
				(pozicija[POLJE[sel].preko[m]] != 2*f))
				return NULL;
	}
	if ((figura == BIJELI) && (POLJE[sel].na < 5))
		pozicija[POLJE[sel].na] = BIJELA_DAMA;
	else if ((figura == CRNI) && (POLJE[sel].na >= 45))
		pozicija[POLJE[sel].na] = CRNA_DAMA;
	else pozicija[POLJE[sel].na] = pozicija[POLJE[sel].sa];
	if (POLJE[sel].sa != POLJE[sel].na)
		pozicija[POLJE[sel].sa] = PRAZNO;

	if (POLJE[sel].preko != NULL) {
		for (int m = maxlevel; --m >= 0; )
			pozicija[POLJE[sel].preko[m]] = PRAZNO;
	}

	if (figura == CRNI) {
		++potez;
		figura = BIJELI;
	}
	else figura = CRNI;

	char lastMove[32];
#ifdef _DEBUG
	char *result = fullDisplay(sel, lastMove);
#else
	char *result = display(sel, lastMove);
#endif
	if (buff != NULL)
		strcpy(buff, lastMove);
	listaPoteza = (char **)realloc(listaPoteza, (broj+1) * sizeof(char *));
	listaPoteza[broj++] = strdup(lastMove);
	return result;
}


int game::MoveNumber(int from, int to)
{
	--from; --to;
	int sel = count;
	while (--sel >= 0) {
		if ((POLJE[sel].na == to) && (POLJE[sel].sa == from))
			return sel;
	}
	return -1;
}


game::~game(void) {
	for (int n = 0; n <= count; ++n) {
		free(POLJE[n].preko);
		POLJE[n].preko = NULL;
	}

	for (n = broj; --n >= 0; free(listaPoteza[n]));
	free(listaPoteza);

	free(bijeli);
	free(crni);
	free(lastComment);
}
