#ifndef _DAMA_H

#define _DAMA_H

#include <string.h>

#define	BROJ_POTEZA	50

class game {
public:
	enum piece {
		BIJELA_DAMA	= 2,
		BIJELI = 1,
		CRNA_DAMA = -2,
		CRNI = -1,
		PRAZNO = 0
	};
private:
	struct potez {
		int	sa;
		int	na;
		int	*preko;
	};
public:
	potez POLJE[BROJ_POTEZA], i_POLJE;
private:
	piece pozicija[50];
	int fig_bijeli, fig_crni;
	void postavi(int, piece);
	piece figura;
	void skok_dame(piece *, int, int, int);
	void skok(piece *, int, int);
	int count, maxlevel;
	int inter[BROJ_POTEZA], polje_start;
	void udarni_potez(piece *);
	void tihi_potez(piece *);
public:
	int potez;
	char *bijeli;
	char *crni;
	~game(void);
	game(char *b = NULL, char *c = NULL) {
		bijeli = (b == NULL) ? NULL : strdup(b);
		crni = (c == NULL) ? NULL : strdup(c);
		memset(&POLJE, 0, sizeof POLJE);
		pocetna_pozicija();
		lastComment = NULL;
		listaPoteza = NULL;
		broj = 0;
	};
	void pocetna_pozicija(void);
	int moguci_potezi(void);
	char *display(int, char * = NULL);
	char *fullDisplay(int, char * = NULL);
	char *MakeMove(int, int, char * = NULL);
	int MoveNumber(int, int);
	piece polje(int n) {
		if ((n < 1) || (n > 50))
			return PRAZNO;
		else
			return pozicija[n-1];
	};
	char *lastComment;
	char **listaPoteza;
	int broj;
};


#endif _DAMA_H
